// File: car.cpp

#include "car.h"
#include <string>
#include <iostream>
#include <sstream>

using namespace std;

Car::Car() {  
    // Fields initialized at declaration
}

Car::Car(const string& color, const string& make, const string& model) {
    this->color = color;
    this->make = make;
    this->model = model;
}

Car::Car(const Car& o) {
    color = o.color;
    make = o.make;
    model = o.model;
}

Car::~Car() {
    // No clean-up necessary.
}

string Car::getColor() const { return color; }
string Car::getMake() const  { return make;  }
string Car::getModel() const { return model; }

void Car::setColor(const string& color) { this->color = color; }
void Car::setMake(const string& make)   { this->make = make;   }
void Car::setModel(const string& model) { this->model = model; }

string Car::toString() const {
    ostringstream oss;
    oss << "A " << color 
        << " " << make 
        << " " << model;
        
    return oss.str();
}