// File: Temp.cpp

#include "Temp.h"
#include <sstream>
#include <iomanip>

using namespace std;


Temp::Temp(const double value, const string& scale) {
    setScale(scale);
    setValue(value);
}// end Temp()


double Temp::getValue() const {
    return value;
}// end getValue()

string Temp::getScale() const {
    return scale;
}// end getScale()


void Temp::setValue(const double value) {
    this->value = value;
}// end setValue()

void Temp::setScale(const string& scale) {
    this->scale = scale;
}// end setScale()

string Temp::toString() const {
    ostringstream oss;

    oss << setiosflags(ios::fixed) << setprecision(1)
        << "Value = " << value
        << ", scale = " << scale;

    return oss.str();
}// end toString()

// Overloaded method operators (+)
Temp Temp::operator +(const double valueIncrement) {
    // Return an anonymous object. Note how the value
    // is incremented for the new object, not the receiving
    // object, whose value is unaffected.

    /* If we wanted the receiving object to be updated, then
     * we would have to do the following:
     * 
     * value += valueIncrement;
     * return Temp(value, scale);
     */
    return {value + valueIncrement};
}// end +()

/* Overloaded function operators (<<)
 * This must be a function overload, since the stream object
 * is required on the left-hand-side (lfs) of the operator.
 */

ostream& operator <<(ostream& os, const Temp& o) {
    /* Call the .toString() method to do all the heavy lifting. */
    os << o.toString();
    return os;
}// end <<()