// File: Temp.h
#ifndef TEMP_H
#define TEMP_H

#include <string>
using namespace std;

class Temp {
private:
    string scale;
    double value;

    // Private utility methods.
    double inDegreesCelcius() const;
    double inDegreesFahrenheit() const;

public:
    explicit Temp(const double value = 0.0, const string& scale = "F");
    virtual ~Temp();

    double getValue() const;
    string getScale() const;

    void setValue(const double value);
    void setScale(const string& scale);

    string toString() const;
    string toString(const string& formatScale) const;

    // Overloaded arithmetic operators. Return type should not be a reference.
    Temp operator +(const double valueIncrement);
    Temp operator -(const double valueIncrement);
    
    Temp operator +(const Temp& addendTemp);

    // Overloaded relational operators.
    bool operator ==(const Temp& rhs);
    bool operator !=(const Temp& rhs);
    bool operator <(const Temp& rhs);
    bool operator <=(const Temp& rhs);
    bool operator >(const Temp& rhs);
    bool operator >=(const Temp& rhs);
};


/* Overloaded << operator
 * This operator must be declared as a function.
 */
ostream& operator <<(ostream& os, const Temp& o);

#endif