// File: Graduate.cpp

#include "Graduate.h"
#include "Student.h"
#include <string>
#include <iostream>
#include <sstream>

using namespace std;

Graduate::Graduate(const int sid, const string& first, const string& last,
                   const bool isOnThesisOption)
    : Student{sid, first, last}, isOnThesisOption{isOnThesisOption} 
{}// end Graduate()

Graduate::~Graduate() { }// end ~Graduate()

bool Graduate::getThesisOption() const                      { return isOnThesisOption;                   }// end getThesisOption()
void Graduate::setThesisOption(const bool isOnThesisOption) { this->isOnThesisOption = isOnThesisOption; }// end setThesisOption()

string Graduate::toString() const {
    ostringstream oss;

    oss << Student::toString()
        << "[" << (isOnThesisOption? "thesis option" : "non-thesis option") << "]";

    return oss.str();
}// end toString()

ostream& operator <<(ostream& os, const Graduate& o) {
    os << o.toString();
    return os;
}// end <<()