// File: Undergraduate.cpp

#include "Undergraduate.h"
#include "Student.h"
#include <string>
#include <iostream>
#include <sstream>

using namespace std;

Undergraduate::Undergraduate(const int sid, const string& first, const string& last,
                             const string& academicYear) 
    : Student{sid, first, last}, academicYear{academicYear}
{}// end Undergraduate()

Undergraduate::~Undergraduate() {  }// end ~Undergraduate()

string Undergraduate::getAcademicYear() const { 
    return academicYear; 
}// end getAcademicYear()

void Undergraduate::setAcademicYear(const string& academicYear) {
    if ( academicYear == "Fr" ||
         academicYear == "So" ||
         academicYear == "Jr" ||
         academicYear == "Sr" ) {
        this->academicYear = academicYear;

    } else {
        cerr << "Invalid academic year: " << academicYear << endl;
    }
}// end setAcademicYear()

string Undergraduate::toString() const {
    ostringstream oss;

    oss << Student::toString()
        << "[" << academicYear << "]";
        
    return oss.str();
}// end toString()

ostream& operator <<(ostream& os, const Undergraduate& o) {
    os << o.toString();
    return os;
}// end <<()