// File: functions.h

/* This file contains the prototypes of the function templates. */

/* First the functions as overloads. */
// int findMinInt(const int num1, const int num2, const int num3);
// char findMinChar(const char ch1, const char ch2, const char ch3);

/* Now as function templates. */
template <typename T>
T findMin(const T& v1, const T& v2, const T& v3) {
    T minValue = v1;

    minValue = (v2 < minValue)? v2 : minValue;
    minValue = (v3 < minValue)? v3 : minValue;

    return minValue;
}