// File: Stack.h

#include "Stack.h"
#include <stdexcept>
#include <iostream>
using namespace std;

template <typename E> 
Stack<E>::Stack()  {}// end Stack()

template <typename E>
Stack<E>::~Stack() {}// end ~Stack()

template <typename E>
void Stack<E>::push(const E& element) {
    if ( top >= STACK_CAPACITY - 1 ) { throw range_error("Stack is full."); }
    elements[++top] = element;
}// end push()

template <typename E>
E Stack<E>::pop() {
    if ( isEmpty() ) { throw range_error("Stack is empty."); }

    E popValue = elements[top--];
    return popValue;
}// end pop()

template <typename E>
E Stack<E>::peek() const {
    if ( isEmpty() ) { throw range_error("Stack is empty."); }
    return elements[top];
}// end peek()

template <typename E>
bool Stack<E>::isEmpty() const { return top == -1; }// end isEmpty()