// File: Stack.h

#ifndef STACK_H
#define STACK_H

#include <stdexcept>
#include <iostream>
using namespace std;

const int STACK_CAPACITY = 100;


template <typename E>
class Stack {
protected:
    E elements[STACK_CAPACITY] = { E{} };
    int top = -1;

public:
    Stack()          {}// end Stack()
    virtual ~Stack() {}// end ~Stack()

    virtual void push(const E& element) final {
        if ( top >= STACK_CAPACITY - 1 ) {
            throw range_error("Stack is full.");
        }
        elements[++top] = element;
    }// end push()

    virtual E pop() final {
        if ( isEmpty() ) {
            throw range_error("Stack is empty.");
        }
        E popValue = elements[top--];
        return popValue;
    }// end pop()

    virtual E peek() final {
        if ( isEmpty() ) {
            throw range_error("Stack is empty.");
        }
        return elements[top];
    }// end peek()

    virtual bool isEmpty() const {
        return top == -1;
    }// end isEmpty()
};// end Stack

#endif