// File: Queue.h

#ifndef QUEUE_H
#define QUEUE_H

#include <stdexcept>
#include <iostream>
using namespace std;

const int QUEUE_CAPACITY = 100;


template <typename E>
class Queue {
private:
    void shiftDown() {
        for (int index = 1; index <= count - 1; index++) {
            elements[index - 1] = elements[index];
        }
        count -= 1;
    }// end shiftDown() 


protected:
    E elements[QUEUE_CAPACITY] = { E{} };
    int count = 0;

public:
    Queue()          {}// end Queue()
    virtual ~Queue() {}// end ~Queue()

    virtual void push(const E& element) final {
        if ( count >= QUEUE_CAPACITY ) {
            throw range_error("Queue is full.");
        }
        elements[count++] = element;
    }// end push()

    virtual E pop() final {
        if ( isEmpty() ) {
            throw range_error("Queue is empty.");
        }
        E popValue = elements[0];

        // shift elements
        shiftDown();

        return popValue;
    }// end pop()

    virtual E peek() final {
        if ( isEmpty() ) {
            throw range_error("Queue is empty.");
        }
        return elements[0];
    }// end peek()

    virtual int getCount() const final {
        return count;
    }// end getCount()

    virtual bool isEmpty() const {
        return count == 0;
    }// end isEmpty()
};// end Queue

#endif