// File: main.cpp

#include "ArrayList.h"
#include <iostream>
#include <iomanip>
using namespace std;


#define TAB(n) setw(n) << " "

int main() {
     ArrayList<int> iList{};

    iList.insertBack(3);
    iList.insertBack(4);
    iList.insertFront(1);
    iList.insertAt(1, 2);
    
    cout << "Original list:"
         << endl
         << TAB(9) << iList
         << endl;

    cout << endl
         << "Updated iList:"
         << endl
         << setw(19) << "removing front: " << iList.removeFront() << " - " << iList
         << endl
         << setw(19) << "removing front: " << iList.removeFront() << " - " << iList
         << endl
         << setw(19) << "removing back: " << iList.removeBack() << " - " << iList
         << endl
         << setw(19) << "removing [0]: " << iList.removeAt(0) << " - " << iList
         << endl;


    cout << endl
         << "Current iList state:"
         << endl
         << TAB(4) <<  "count: " << iList.count
         << ", isEmpty: " << (iList.isEmpty? "yes" : "no")
         << endl;


    ArrayList<int> cList(iList);
    cout << endl
         << "Making a copy of iList: cList:"
         << endl
         << TAB(4) << "iList: " << iList
         << endl
         << TAB(4) << "cList: " << cList
         << endl;

    cList.insertBack(1);
    cList.insertBack(2);
    cList.insertBack(3);

    cout << endl
         << "Updating cList: (3) items added."
         << endl
         << TAB(4) << "iList: " << iList
         << endl
         << TAB(4) << "cList: " << cList
         << endl;

    iList = cList;
    cout << endl
         << "Assigning cList to iList:"
         << endl
         << TAB(4) << "iList: " << iList
         << endl
         << TAB(4) << "cList: " << cList
         << endl;

    iList.insertBack(10);
    cout << endl
         << "Updating iList: (1) item added."
         << endl
         << TAB(4) << "iList: " << iList
         << endl
         << TAB(4) << "cList: " << cList
         << endl;

    return 0;
}// end main()