// File: main.cpp

#include "LinkedList.h"
#include <iostream>
#include <string>
#include <iomanip>

using namespace std;

int main() {
    LinkedList<string> posList{};

    cout << "Begin Testing:" << endl << endl;
    cout << setw(20) << "Empty poslist: " << posList << endl;

    /* Add some nodes */
    posList.add(0, "E");
    posList.add(0, "C");
    posList.add(0, "B");
    posList.add(3, "F");

    cout << setw(20) << "Original poslist: " << posList << endl;

    try {
        posList.add(11, "K");

    } catch (range_error e) {
        cerr << "Push - " << e.what() << endl;
    }

    /* Remove some nodes */
    cout << endl << "Remove posList: " << posList.removeAt(0);
    cout << endl << "Remove posList: " << posList.removeAt(posList.size() - 1);
    cout << endl << "Remove posList: " << posList.removeAt(1);

    cout << endl << "Edited poslist: " << posList << endl;

    
    LinkedList<string> valueList{};

    valueList.add("A");
    valueList.add("D");
    valueList.add("G");

    cout << endl << setw(20) << "Original valuelist: " << valueList << endl;
    try {
        valueList.remove("H");

    } catch (const logic_error& e) {
        cerr << "Remove - " << e.what() << endl;
    }

    cout << endl << setw(24) << "Set valueList first: A1";          valueList.set(0, "A1");
    cout << endl << setw(24) << "Set valueList middle: D1";         valueList.set(1, "D1");
    cout << endl << setw(24) << "Set valueList last: G1";           valueList.set(2, "G1");
    cout << endl << setw(22
    ) << "Original valuelist: " << valueList << endl;

    cout << endl << setw(18) << "valueList First: " << valueList.get(0)
         << endl << setw(18) << "valueList Middle: " << valueList.get(1)
         << endl << setw(18) << "valueList Last: " << valueList.get( valueList.size() - 1)
         << endl;

    cout << endl 
         << "posList contains D? " << ( posList.contains("D")? "Yes" : "No" )
        << endl
        << "posList contains C? " << ( posList.contains("C") ? "Yes" : "No" )
        << endl;

    LinkedList<string> copyPosList = posList;
    posList.add(1, "AA");

    cout << endl
         << setw(15) << "copyPosList: " << copyPosList
         << endl
         << setw(15) << "posList: " << posList
         << endl;

    LinkedList<string> assignPosList;
    assignPosList = posList;
    posList.add(2, "FF");
    
    cout << endl
         << setw(15) << "assignList: " << assignPosList
         << endl
         << setw(15) << "list: " << posList
         << endl;

    cout << endl << "End Testing:" << endl;

    cout << endl;
    return 0;
}// end main()