// File: main.cpp

#include "LinkedList.h"
#include <iostream>
#include <string>
#include <iomanip>

using namespace std;

int main() {
    LinkedList<string> list;

    cout << "Begin Testing:" << endl << endl;

    cout << setw(15) << "Empty list: " << list << endl;

    /* Add some nodes */
    list.pushBack("E");
    list.pushFront("C");
    list.pushAt(0, "B");
    list.pushAt(3, "F");
    list.push("A");
    list.push("G");
    list.push("D");

    cout << setw(15) << "Original list: " << list << endl;

    try {
        list.pushAt(11, "K");

    } catch (range_error e) {
        cerr << "Push - " << e.what() << endl;
    }

    /* Remove some nodes */
    cout << endl << "Remove: " << list.popFront();
    cout << endl << "Remove: " << list.popBack();
    cout << endl << "Remove: " << list.popAt(1);
    cout << endl << "Remove: " << list.pop("F");

    cout << endl << "Edited list: " << list << endl;

    try {
        list.pop("H");

    } catch (const logic_error& e) {
        cerr << "Pop - " << e.what() << endl;
    }

    cout << endl << "Set first: B1";
    list.setAt(0, "B1");
    cout << endl << "Set middle: D1";
    list.setAt(1, "D1");
    cout << endl << "Set last: E1";
    list.setAt(2, "E1");
    cout << endl << setw(20) << "Original valuelist: " << list << endl;

    cout << endl
         << "First: " << list.getFront()
         << endl
         << "Middle: " << list.getAt(1)
         << endl
         << "Last: " << list.getBack()
         << endl;

    cout << endl 
         << "List contains D? " << ( list.contains("D")? "Yes" : "No" )
        << endl
        << "List contains H? " << ( list.contains("H") ? "Yes" : "No" )
        << endl;

    LinkedList<string> copyList = list;
    list.push("AA");

    cout << endl
         << setw(10) << "copyList: " << copyList
         << endl
         << setw(10) << "list: " << list
         << endl;

    LinkedList<string> assignList;
    assignList = list;
    list.pushBack("FF");
    
    cout << endl
         << setw(12) << "assignList: " << assignList
         << endl
         << setw(12) << "list: " << list
         << endl;

    cout << endl << "End Testing:" << endl;

    cout << endl;

    return 0;
}// end main()